{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65000,0,655360}
type vect=array[0..200] of  double;
     vvvv=array[0..200] of  integer;

var
   fil                          :text;
   N,i,j,k,xn,yn,p,q            :integer;
   X1,Y1,X2,Y2,X,Y              :vect;
   xi1,xi2,yi1,yi2              :integer;
   tmp                          :double;
   A                            :array[0..200] of ^vvvv;

Procedure Insert(v:double;var a:vect; var n:integer);
var i:integer;
begin
  for i:=1 to n do if a[i]=v then exit;
  inc(n);
  a[n]:=v
end;

Function Min(m1,m2:double):double;
begin
  if m1<m2 then Min:=m1 else Min:=m2
end;

Function Max(m1,m2:double):double;
begin
  if m1<m2 then Max:=m2 else Max:=m1
end;

Procedure QS(var v:vect;var n:integer;li,ls:integer);
var k:double;
    i,j:integer;
begin
  i:=li; j:=ls; k:=v[(li+ls) div 2];
  repeat
      while v[i]<k do inc(i);
      while v[j]>k do dec(j);
      if i<=j then
       begin tmp:=v[i]; v[i]:=v[j]; v[j]:=tmp; inc(i); dec(j) end;
  until i>j;
  if i<ls then qs(v,n,i,ls);
  if j>li then qs(v,n,li,j);
end;

begin
   assign(fil,'PETICE.IN');
   reset(fil);
   readln(fil,N);
   xn:=0;
   yn:=0;
   for i:=1 to N do
   begin
     readln(fil,x1[i],y1[i],x2[i],y2[i]);
     insert(x1[i],x,xn);
     insert(x2[i],x,xn);
     insert(y1[i],y,yn);
     insert(y2[i],y,yn);
   end;
   close(fil);
   QS(x,xn,1,xn);
   QS(y,yn,1,yn);

   for i:=0 to 200 do begin new(a[i]); fillchar(a[i]^,sizeof(a[i]^),0) end;
   for i:=1 to N do
   begin
     x1[0]:=Min(x1[i],x2[i]);
     x2[0]:=Max(x1[i],x2[i]);
     y1[0]:=Min(y1[i],y2[i]);
     y2[0]:=Max(y1[i],y2[i]);
     for xi1:=1 to xn    do if x[xi1]=x1[0] then break;
     for xi2:=xi1 to xn  do if x[xi2]=x2[0] then break;
     for yi1:=1 to yn    do if y[yi1]=y1[0] then break;
     for yi2:=yi1 to yn  do if y[yi2]=y2[0] then break;
     inc(a[xi1]^[yi1]);
     inc(a[xi2]^[yi2]);
     dec(a[xi1]^[yi2]);
     dec(a[xi2]^[yi1]);
   end;
   tmp:=0;

   for j:=1 to yn do
   begin
     k:=0;
     for i:=1 to xn do begin k:=k+a[i]^[j]; a[i]^[j]:=k end;
   end;

   for i:=1 to xn do
   begin
     k:=0;
     for j:=1 to yn do begin k:=k+a[i]^[j]; a[i]^[j]:=k end;
   end;

   for i:=1 to xn-1 do
    for j:=1 to yn-1 do
      if A[i]^[j]>0 then tmp:=tmp+(X[i+1]-X[i])*(Y[j+1]-Y[j]);

   assign(fil,'PETICE.OUT');
   rewrite(fil);
   writeln(fil,tmp:0:3);
   close(fil)

end.