#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char a[ 201][ 201], n;
int c[ 201], d[ 201], s[ 201], unr[ 201], din[ 201], dout[ 201];
int ch[ 405], chl, m, kill, waskilled[ 201];
char far b[ 201][ 201];

void read_data()
{
	FILE *f;
	int i, j, m;

	f = fopen( "trasee.in", "rt");
	fscanf( f, "%d %d", &n, &m);
	while( m--)
	{
		fscanf( f, "%d %d", &i, &j);
		a[ i][ j] = 1;
		din[ j]++; dout[ i]++;
	}
	fclose( f);

	for( i = 1; i <= n; i++)
		if( !din[ i] || !dout[ i])
			unr[ i] = 1;
}

int nextc( int node);

int nextd( int node)
{
	int i, schl;

	ch[ chl++] = node;
	s[ node] = 1;

	schl = chl;
	for( i = 1; i <= n; i++)
		if( a[ node][ i] && i != c[ node]/* && !s[ i]*/)
		{
			if( nextc( i))
				return 1;
			else
				chl = schl;
		}

/*	if( d[ node] != -1 && chl > 1)
		return 1;
	else
*/
	return 0;
}

int nextc( int node)
{
	int i, schl;

	ch[ chl++] = node;
	s[ node] = 1;
	schl = chl;

	if( d[ node] == -1)
		return 1;

	if( nextd( d[ node]))
		return 1;
	else
	{
		chl = schl;
		return 0;
	}
}

int find_chain()
{
	int i;

	chl = 0;
	for( i = 1; i <= n; i++)
		if( c[ i] == -1)
		{
			memset( s, 0, sizeof( s));
			chl = 0;
			if( nextd( i))
				break;
		}

	if( i <= n)
		return 1;
	else
		return 0;
}

void update_chain()
{
	int i;

	if( chl & 1)
	{
		c[ ch[ chl-1]] = -1;
		chl--;
	}
		
	for( i = 0; i < chl; i++)
		if( !( i & 1))
		{
			c[ ch[ i]] = ch[ i+1];
			d[ ch[ i+1]] = ch[ i];
		} 
}

void init()
{
	int i;

	for( i = 1; i <= n; i++)
		c[ i] = d[ i] = -1;

	for( i = 1; i <= n; i++)
		if( unr[ i])
			c[ i] = d[ i] = i;
}

void df( int node)
{
	if( c[ node] == -1)
	{
		c[ node] = d[ node] = node;
		m++;
		kill = 1;
		waskilled[ node] = 1;
		return;
	}
	
	s[ node] = 1;

	if( !s[ c[ node]])
		df( c[ node]);
	else
		m++;

	if( kill || waskilled[ c[ node]])
	{
		c[ node] = d[ node] = node;
		waskilled[ node] = 1;
	}
}

void df2( FILE *f, int node)
{
	s[ node] = 1;

	fprintf( f, "%d ", node);

	if( !s[ c[ node]])
		df2( f, c[ node]);
	else
		fprintf( f, "%d\n", c[ node]);
}

void write_sol()
{
	FILE *f;
	int i;

	memset( s, 0, sizeof( s));
	for( i = 1; i <= n; i++)
		if( !s[ i])
		{
			kill = 0;
			df( i);
		}

	f = fopen( "trasee.out", "wt");
	fprintf( f, "%d\n", m);
	memset( s, 0, sizeof( s));
	for( i = 1; i <= n; i++)
		if( !s[ i])
			df2( f, i);
	fclose( f);
}

void df3( int node, int orig)
{
	if( node == -1)
		return;
	
	s[ node] = 1;
	b[ orig][ node] = 1;

	if( !s[ c[ node]])
		df3( c[ node], orig);
}

void build_b()
{
	int i;

	for( i = 1; i <= n; i++)
	{
		memset( s, 0, sizeof( s));
		df3( i, i);
	}
}

void df4( int node, int orig)
{
	int i;

	if( node == -1)
		return;
	s[ node] = 1;

	if( c[ node] == -1)
		return;

	if( c[ c[ node]] == -1)
	{
		for( i = 1; i <= n; i++)
			if( d[ i] == -1 && b[ i][ orig] && a[ node][ i])
			{
				d[ c[ node]] = -1;
				c[ node] = i;
				d[ i] = node;
			}
	}

	if( !s[ c[ node]])
		df4( c[ node], orig);
}

void fix_holes()
{
	int i;	

	memset( s, 0, sizeof( s));
	for( i = 1; i <= n; i++)
		if( !s[ i])
			df4( i, i);
}

void main()
{
	read_data();

	init();

	while( find_chain())
		update_chain();

	build_b();
	fix_holes();

#if 0
	int i;
	for( i = 1; i <= n; i++)
		printf( "%d - %d\n", i, c[ i]);
	printf( "\n");
#endif
	write_sol();
}